#ifndef _IMQDST_HPP_
#define _IMQDST_HPP_

//  Library:       MQSeries
//  Component:     IMQI (MQSeries C++ MQI)
//  Part:          IMQDST.HPP
//
//  Description:   "ImqDistributionList" class declaration
//
//  Statement:     Licensed Materials - Property of IBM                          
//                                                               
//                 84H2000, 5765-B73                                   
//                 84H2001, 5639-B42                                   
//                 84H2002, 5765-B74                                   
//                 84H2003, 5765-B75                                   
//                 84H2004, 5639-B43                                   
//                 (C) Copyright IBM Corp. 1994, 1997                       
//
//                 U.S. Government Users Restricted Rights -
//                 use, duplication or disclosure restricted by
//                 GSA ADP Schedule Contract with IBM Corp.

#include <imqque.hpp> // ImqQueue

#define ImqDistributionList ImqDst

class ImqDistributionList : public ImqQueue {
  ImqQueue * opfirstDistributedQueue;
protected :
  friend class ImqQueue ;
  // Overloaded "ImqObject" methods:
  virtual void openInformationDisperse ( );
  virtual ImqBoolean openInformationPrepare ( );
  // Overloaded "ImqQueue" methods:
  virtual void putInformationDisperse ( ImqPmo & );
  virtual ImqBoolean putInformationPrepare ( const ImqMsg &, ImqPmo & );
  // New methods:
  void setFirstDistributedQueue ( ImqQueue * pqueue = 0 )
    { opfirstDistributedQueue = pqueue ; }
public :
  // New methods:
  ImqDistributionList ( );
  ImqDistributionList ( const ImqDistributionList & );
  virtual ~ ImqDistributionList ( );
  void operator = ( const ImqDistributionList & );
  ImqQueue * firstDistributedQueue ( ) const
    { return opfirstDistributedQueue ; }
} ;

#endif
