#ifndef _IMQMTR_HPP_
#define _IMQMTR_HPP_

//  Library:       MQSeries
//  Component:     IMQI (MQSeries C++ MQI)
//  Part:          IMQMTR.HPP
//
//  Description:   "ImqMessageTracker" class declaration
//
//  Statement:     Licensed Materials - Property of IBM                          
//                                                               
//                 84H2000, 5765-B73                                   
//                 84H2001, 5639-B42                                   
//                 84H2002, 5765-B74                                   
//                 84H2003, 5765-B75                                   
//                 84H2004, 5639-B43                                   
//                 (C) Copyright IBM Corp. 1994, 1997                       
//
//                 U.S. Government Users Restricted Rights -
//                 use, duplication or disclosure restricted by
//                 GSA ADP Schedule Contract with IBM Corp.

#include <imqbin.hpp> // ImqBinary

#define ImqMessageTracker ImqMtr

class ImqMessageTracker : public virtual ImqError {
protected :
  void * opvoidAccountingToken ;
  void * opvoidCorrelationId ;
  MQLONG * oplFeedback ;
  void * opvoidGroupId ;
  void * opvoidMessageId ;
public :
  // New methods:
  ImqMessageTracker ( );
  ImqMessageTracker ( const ImqMessageTracker & );
  virtual ~ ImqMessageTracker ( );
  void operator = ( const ImqMessageTracker & );
  ImqBinary accountingToken ( ) const ;
  ImqBinary correlationId ( ) const ;
  MQLONG feedback ( ) const ;
  ImqBinary groupId ( ) const ;
  ImqBinary messageId ( ) const ;
  ImqBoolean setAccountingToken ( const ImqBinary & );
  void setAccountingToken ( const unsigned char * = 0 );
  ImqBoolean setCorrelationId ( const ImqBinary & );
  void setCorrelationId ( const unsigned char * = 0 );
  void setFeedback ( const MQLONG );
  ImqBoolean setGroupId ( const ImqBinary & );
  void setGroupId ( const unsigned char * = 0 );
  ImqBoolean setMessageId ( const ImqBinary & );
  void setMessageId ( const unsigned char * = 0 );
} ;

#endif
